<?php

/*
+--------------------------------------------------
|				-::- functions.php -::-
| -------------------------------------------------
|
|	Made by FOPT_Cloudberry (cloudberry@fopt-clan.de)
|	and Olympus_Hermes (currently retired from online gaming)
|	(c) Copyright FOPT_Cloudberry 2004
|	Website http://cloudmods.net
|
| -------------------------------------------------
|
|	Work began Fri, July 2nd 2004
|	Version 1.0
|
| -------------------------------------------------
*/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms available from CloudMods.
 *
 ***************************************************************************/

function sorter( $arrayA, $arrayB ){ 
	if( $arrayA['rating'] == $arrayB['rating'] ) 
		return 0; 
	return( $arrayA['rating'] > $arrayB['rating'] ? -1 : 1 ); 
}

function parse_profile(&$profile)
{
	$data = array();
	preg_match('#<TD CLASS="title1"><U>(\w+)</U></TD>#i', $profile, $regs);
	$data['nick'] = $regs[1];
	
	// ~~ First capture the table with the actual AoC ratings. If there isn't, return all variables empty. ~~
	if( strstr($profile, "Age of Empires II Expansion") )
	{
		$pos = strpos($profile, 'Age of Empires II Expansion');
		$block = substr($profile, $pos, 1061);
		
		// Parse it properly, and obtain the ratings as fast as possible
		$pos = strpos($block, 'Details</A>&nbsp;</TD><TD ALIGN="right"> <SPAN CLASS="text3">');
		$data['rating'] = substr($block, ($pos + 61), 4);
		$pos = strpos($block, '"16px"></TD><TD ALIGN="left" CLASS="blue3">');
            $sub_block = substr($block, ($pos+62), 335);

		$sub_block = substr(strstr($sub_block, 'blue3">'), 7);
		$data['wins'] = (int)substr($sub_block, 6, (strpos($sub_block, "<")-1));
		$sub_block = substr(strstr($sub_block, 'blue3">'), 7);
		$data['losses'] = (int)substr($sub_block, 0, strpos($sub_block, "<"));
		$sub_block = substr(strstr($sub_block, 'blue3">'), 7);
		$data['ties'] = (int)substr($sub_block, 0, strpos($sub_block, "<"));
		$sub_block = substr(strstr($sub_block, 'blue3">'), 7);
		$data['incomp'] = (int)substr($sub_block, 0, strpos($sub_block, "<"));
		$sub_block = substr(strstr($sub_block, 'blue3">'), 7);
		$data['streak'] = (int)substr($sub_block, 0, strpos($sub_block, "<"));
		$data['games'] = intval($data['wins']) + intval($data['losses']);
		$data['winpercent'] = floor((100 * $data['wins']) / $data['games']). "%";
		$data['wotc_nick'] = '-';
		$data['rank'] = '-';
	}
	else
	{
		$data['wotc_nick'] = '-';
		$data['rank'] = '-';
		$data['rating'] = '-';
		$data['games'] = '-';
		$data['wins'] = '-';
		$data['losses'] = '-';
		$data['ties'] = '-';
		$data['incomp'] = '-';
		$data['streak'] = '-';
		$data['winpercent'] = '-';
		$data['date'] = '-';
	}
	
	return $data;	
}

function parse_gp_profile(&$rep)
{
	$data = array();

	$data['wotc_nick'] = '-';
	$data['rank'] = '-';
	$data['rating'] = '-';
	$data['games'] = '-';
	$data['wins'] = '-';
	$data['losses'] = '-';
	$data['ties'] = '-';
	$data['incomp'] = '-';
	$data['streak'] = '-';
	$data['winpercent'] = '-';
	$data['date'] = '-';
	
	$pos = strpos($rep, "Rating :", 512);
	if ($pos == false) {
		return(false);
	}

	$pos = strpos("$rep", "</td>", $pos);
	$pos +=10;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['rating'] = substr($rep, $pos, 4);
	$pos = strpos("$rep", "Streak", $pos);
	$pos = strpos("$rep", ">", $pos + 40);
	$pos ++;
	$data['games'] = (int)substr($rep, $pos, 4);
	$pos += 15;
	$pos = strpos("$rep", "<td", $pos);
	$pos ++;
	$pos = strpos("$rep", "<td", $pos);
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['wins'] = (int)substr($rep, $pos, 4);
	$pos += 15;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['losses'] = (int)substr($rep, $pos, 4);
	$pos += 15;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['incomp'] = (int)substr($rep, $pos, 4);
	$pos += 15;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['streak'] = (int)substr($rep, $pos, 4);
	$data['winpercent'] = floor((100 * $data['wins']) / $data['games']). "%";

	return $data;	
}

function parse_igz_profile(&$rep)
{
	$data = array();

	$data['wotc_nick'] = '-';
	$data['rank'] = '-';
	$data['rating'] = '-';
	$data['games'] = '-';
	$data['wins'] = '-';
	$data['losses'] = '-';
	$data['ties'] = '-';
	$data['incomp'] = '-';
	$data['streak'] = '-';
	$data['winpercent'] = '-';
	$data['date'] = '-';

	$pos = strpos($rep, "Username:", 512);
	if ($pos == false) {
		return(false);
	}
	$pos +=20;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$pos2 = strpos("$rep", "<", $pos);
	$size = $pos2 - $pos;
	$data['wotc_nick'] = substr($rep, $pos, $size);

	$pos = strpos($rep, "AoC - Random Map", $pos2);
	if ($pos == false)
		return $data;	

	$pos +=40;
	$pos = strpos($rep, "Last Result", $pos);

	$pos = strpos("$rep", "class=\"odd\"", $pos);
	$pos +=16;
	$data['date'] = strtotime(substr($rep, $pos, 19));
	/*
	$data['date'] = substr($rep, $pos, 19);
	echo $data['date'] . ", " . strtotime($data['date']) . "<br>";
	*/
	$pos +=9;
	$pos = strpos("$rep", "</td>", $pos);
	$pos +=5;
	$pos = strpos("$rep", "</td>", $pos);
	$pos +=10;
	$pos = strpos("$rep", "</td>", $pos);
	$pos +=9;
	$data['rating'] = substr($rep, $pos, 4);
	$pos +=20;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['wins'] = (int)substr($rep, $pos, 4);
	$pos +=20;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['losses'] = (int)substr($rep, $pos, 4);
	$pos +=20;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['incomp'] = (int)substr($rep, $pos, 4);
	$pos +=20;
	$pos = strpos("$rep", ">", $pos);
	$pos ++;
	$data['streak'] = (int)substr($rep, $pos, 4);
	$data['games'] = $data['wins'] + $data['losses'] + $data['incomp'];
	if ($data['games'] != 0)
		$data['winpercent'] = floor((100 * $data['wins']) / $data['games']). "%";

	return $data;	
}

function give_class()
{
	static $class;
	
	if( $class == 'row1' )
	{
		$class  = 'row2';
	}
	else
	{
		$class = 'row1';
	}
	
	return $class;
}

/*
$data = file_get_contents("949");
parse_igz_profile($data);
*/

?>
